/* WifiMenuItem.c generated by valac 0.40.13, the Vala compiler
 * generated from WifiMenuItem.vala, do not modify */

/*-
 * Copyright (c) 2015-2018 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <NetworkManager.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define NETWORK_TYPE_WIFI_MENU_ITEM (network_wifi_menu_item_get_type ())
#define NETWORK_WIFI_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem))
#define NETWORK_WIFI_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItemClass))
#define NETWORK_IS_WIFI_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_WIFI_MENU_ITEM))
#define NETWORK_IS_WIFI_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_WIFI_MENU_ITEM))
#define NETWORK_WIFI_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItemClass))

typedef struct _NetworkWifiMenuItem NetworkWifiMenuItem;
typedef struct _NetworkWifiMenuItemClass NetworkWifiMenuItemClass;
typedef struct _NetworkWifiMenuItemPrivate NetworkWifiMenuItemPrivate;
typedef enum  {
	NETWORK_STATE_DISCONNECTED,
	NETWORK_STATE_WIRED_UNPLUGGED,
	NETWORK_STATE_CONNECTED_WIRED,
	NETWORK_STATE_CONNECTED_VPN,
	NETWORK_STATE_CONNECTED_MOBILE,
	NETWORK_STATE_CONNECTED_WIFI,
	NETWORK_STATE_CONNECTED_WIFI_WEAK,
	NETWORK_STATE_CONNECTED_WIFI_OK,
	NETWORK_STATE_CONNECTED_WIFI_GOOD,
	NETWORK_STATE_CONNECTED_WIFI_EXCELLENT,
	NETWORK_STATE_CONNECTING_WIFI,
	NETWORK_STATE_CONNECTING_WIRED,
	NETWORK_STATE_CONNECTING_MOBILE,
	NETWORK_STATE_CONNECTING_VPN,
	NETWORK_STATE_FAILED_WIRED,
	NETWORK_STATE_FAILED_WIFI,
	NETWORK_STATE_FAILED_MOBILE,
	NETWORK_STATE_FAILED_VPN
} NetworkState;


#define NETWORK_TYPE_STATE (network_state_get_type ())
enum  {
	NETWORK_WIFI_MENU_ITEM_0_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_AP_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL,
	NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS
};
static guint network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS] = {0};

struct _NetworkWifiMenuItem {
	GtkListBoxRow parent_instance;
	NetworkWifiMenuItemPrivate * priv;
	gboolean is_secured;
};

struct _NetworkWifiMenuItemClass {
	GtkListBoxRowClass parent_class;
};

struct _NetworkWifiMenuItemPrivate {
	GeeLinkedList* _ap;
	NetworkState _state;
	gboolean _active;
	gboolean show_icons;
	NMAccessPoint* _tmp_ap;
	GtkRadioButton* radio_button;
	GtkImage* img_strength;
	GtkImage* lock_img;
	GtkImage* error_img;
	GtkSpinner* spinner;
};


static gpointer network_wifi_menu_item_parent_class = NULL;

GType network_wifi_menu_item_get_type (void) G_GNUC_CONST;
GType network_state_get_type (void) G_GNUC_CONST;
#define NETWORK_WIFI_MENU_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItemPrivate))
NetworkWifiMenuItem* network_wifi_menu_item_new (NMAccessPoint* ap,
                                                 NetworkWifiMenuItem* previous);
NetworkWifiMenuItem* network_wifi_menu_item_construct (GType object_type,
                                                       NMAccessPoint* ap,
                                                       NetworkWifiMenuItem* previous);
void network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self,
                                    NMAccessPoint* ap);
static void network_wifi_menu_item_update (NetworkWifiMenuItem* self);
static void _network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static gboolean __lambda13_ (NetworkWifiMenuItem* self,
                      GtkWidget* b,
                      GdkEventButton* ev);
static gboolean ___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
NetworkWifiMenuItem* network_wifi_menu_item_new_blank (void);
NetworkWifiMenuItem* network_wifi_menu_item_construct_blank (GType object_type);
static void network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self);
NMAccessPoint* network_wifi_menu_item_get_ap (NetworkWifiMenuItem* self);
static gchar* network_wifi_menu_item_strength_to_string (NetworkWifiMenuItem* self,
                                                  guint8 strength);
guint8 network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
NetworkState network_wifi_menu_item_get_state (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
void network_wifi_menu_item_hide_icons (NetworkWifiMenuItem* self);
gboolean network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self,
                                           NMAccessPoint* ap);
GBytes* network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self);
void network_wifi_menu_item_set_state (NetworkWifiMenuItem* self,
                                       NetworkState value);
gboolean network_wifi_menu_item_get_active (NetworkWifiMenuItem* self);
void network_wifi_menu_item_set_active (NetworkWifiMenuItem* self,
                                        gboolean value);
static void network_wifi_menu_item_finalize (GObject * obj);
static void _vala_network_wifi_menu_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_menu_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);


static void
_network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
	network_wifi_menu_item_update ((NetworkWifiMenuItem*) self);
}


static gboolean
__lambda13_ (NetworkWifiMenuItem* self,
             GtkWidget* b,
             GdkEventButton* ev)
{
	gboolean result = FALSE;
	g_return_val_if_fail (b != NULL, FALSE);
	g_return_val_if_fail (ev != NULL, FALSE);
	g_signal_emit (self, network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL], 0);
	result = FALSE;
	return result;
}


static gboolean
___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda13_ ((NetworkWifiMenuItem*) self, _sender, event);
	return result;
}


NetworkWifiMenuItem*
network_wifi_menu_item_construct (GType object_type,
                                  NMAccessPoint* ap,
                                  NetworkWifiMenuItem* previous)
{
	NetworkWifiMenuItem * self = NULL;
	GtkRadioButton* _tmp0_;
	GtkRadioButton* _tmp1_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkSpinner* _tmp10_;
	GtkSpinner* _tmp11_;
	GtkSpinner* _tmp12_;
	GtkSpinner* _tmp13_;
	GtkSpinner* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp17_;
	GtkRadioButton* _tmp18_;
	GtkSpinner* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	GeeLinkedList* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkRadioButton* _tmp25_;
	GtkRadioButton* _tmp26_;
	g_return_val_if_fail (ap != NULL, NULL);
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->radio_button);
	self->priv->radio_button = _tmp0_;
	_tmp1_ = self->priv->radio_button;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
	if (previous != NULL) {
		GtkRadioButton* _tmp2_;
		GtkRadioButton* _tmp3_;
		GSList* _tmp4_;
		_tmp2_ = self->priv->radio_button;
		_tmp3_ = previous->priv->radio_button;
		_tmp4_ = gtk_radio_button_get_group (_tmp3_);
		gtk_radio_button_set_group (_tmp2_, _tmp4_);
	}
	_tmp5_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->img_strength);
	self->priv->img_strength = _tmp5_;
	_tmp6_ = self->priv->img_strength;
	g_object_set (_tmp6_, "icon-size", (gint) GTK_ICON_SIZE_MENU, NULL);
	_tmp7_ = (GtkImage*) gtk_image_new_from_icon_name ("channel-insecure-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->lock_img);
	self->priv->lock_img = _tmp7_;
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->error_img);
	self->priv->error_img = _tmp8_;
	_tmp9_ = self->priv->error_img;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _ ("This wireless network could not be connected to."));
	_tmp10_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->spinner);
	self->priv->spinner = _tmp10_;
	_tmp11_ = self->priv->spinner;
	gtk_spinner_start (_tmp11_);
	_tmp12_ = self->priv->spinner;
	gtk_widget_set_visible ((GtkWidget*) _tmp12_, FALSE);
	_tmp13_ = self->priv->spinner;
	_tmp14_ = self->priv->spinner;
	_tmp15_ = gtk_widget_get_visible ((GtkWidget*) _tmp14_);
	_tmp16_ = _tmp15_;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp13_, !_tmp16_);
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp17_);
	main_grid = _tmp17_;
	gtk_widget_set_valign ((GtkWidget*) main_grid, GTK_ALIGN_CENTER);
	gtk_grid_set_column_spacing (main_grid, 6);
	gtk_widget_set_margin_start ((GtkWidget*) main_grid, 6);
	gtk_widget_set_margin_end ((GtkWidget*) main_grid, 6);
	_tmp18_ = self->priv->radio_button;
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp18_);
	_tmp19_ = self->priv->spinner;
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->error_img;
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp20_);
	_tmp21_ = self->priv->lock_img;
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp21_);
	_tmp22_ = self->priv->img_strength;
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp22_);
	_tmp23_ = gee_linked_list_new (nm_access_point_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->_ap);
	self->priv->_ap = _tmp23_;
	network_wifi_menu_item_add_ap (self, ap);
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp24_, "menuitem");
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) main_grid);
	_tmp25_ = self->priv->radio_button;
	g_object_bind_property_with_closures ((GObject*) self, "active", (GObject*) _tmp25_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::active", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
	_tmp26_ = self->priv->radio_button;
	g_signal_connect_object ((GtkWidget*) _tmp26_, "button-release-event", (GCallback) ___lambda13__gtk_widget_button_release_event, self, 0);
	network_wifi_menu_item_update (self);
	_g_object_unref0 (main_grid);
	return self;
}


NetworkWifiMenuItem*
network_wifi_menu_item_new (NMAccessPoint* ap,
                            NetworkWifiMenuItem* previous)
{
	return network_wifi_menu_item_construct (NETWORK_TYPE_WIFI_MENU_ITEM, ap, previous);
}


/**
     * Only used for an item which is not displayed: hacky way to have no radio button selected.
     **/
NetworkWifiMenuItem*
network_wifi_menu_item_construct_blank (GType object_type)
{
	NetworkWifiMenuItem * self = NULL;
	GtkRadioButton* _tmp0_;
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->radio_button);
	self->priv->radio_button = _tmp0_;
	return self;
}


NetworkWifiMenuItem*
network_wifi_menu_item_new_blank (void)
{
	return network_wifi_menu_item_construct_blank (NETWORK_TYPE_WIFI_MENU_ITEM);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self)
{
	guint8 strength = 0U;
	g_return_if_fail (self != NULL);
	strength = (guint8) 0;
	{
		GeeLinkedList* _ap_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _ap_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _ap_index = 0;
		_tmp0_ = self->priv->_ap;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_ap_list = _tmp1_;
		_tmp2_ = _ap_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_ap_size = _tmp4_;
		_ap_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			NMAccessPoint* ap = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			NMAccessPoint* _tmp11_ = NULL;
			guint8 _tmp12_;
			NMAccessPoint* _tmp13_;
			guint8 _tmp14_;
			guint8 _tmp15_;
			NMAccessPoint* _tmp18_;
			guint8 _tmp19_;
			NMAccessPoint* _tmp20_;
			guint8 _tmp21_;
			guint8 _tmp22_;
			_tmp5_ = _ap_index;
			_ap_index = _tmp5_ + 1;
			_tmp6_ = _ap_index;
			_tmp7_ = _ap_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _ap_list;
			_tmp9_ = _ap_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			ap = (NMAccessPoint*) _tmp10_;
			_tmp12_ = strength;
			_tmp13_ = ap;
			_tmp14_ = nm_access_point_get_strength (_tmp13_);
			_tmp15_ = _tmp14_;
			if (_tmp12_ > _tmp15_) {
				NMAccessPoint* _tmp16_;
				_tmp16_ = self->priv->_tmp_ap;
				_tmp11_ = _tmp16_;
			} else {
				NMAccessPoint* _tmp17_;
				_tmp17_ = ap;
				_tmp11_ = _tmp17_;
			}
			_tmp18_ = _g_object_ref0 (_tmp11_);
			_g_object_unref0 (self->priv->_tmp_ap);
			self->priv->_tmp_ap = _tmp18_;
			_tmp19_ = strength;
			_tmp20_ = ap;
			_tmp21_ = nm_access_point_get_strength (_tmp20_);
			_tmp22_ = _tmp21_;
			strength = MAX (_tmp19_, _tmp22_);
			_g_object_unref0 (ap);
		}
		_g_object_unref0 (_ap_list);
	}
}


static void
network_wifi_menu_item_update (NetworkWifiMenuItem* self)
{
	GtkRadioButton* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	GBytes* _tmp3_;
	gsize _tmp4_ = 0;
	guint8* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	NetworkState _tmp36_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->radio_button;
	_tmp1_ = network_wifi_menu_item_get_ap (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = nm_access_point_get_ssid (_tmp2_);
	_tmp5_ = g_bytes_get_data (_tmp3_, &_tmp4_);
	_tmp6_ = nm_utils_ssid_to_utf8 (_tmp5_, (gsize) _tmp4_);
	_tmp7_ = _tmp6_;
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = self->priv->show_icons;
	if (_tmp8_) {
		GtkImage* _tmp9_;
		guint8 _tmp10_;
		guint8 _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GtkImage* _tmp18_;
		NM80211ApSecurityFlags flags = 0;
		NMAccessPoint* _tmp19_;
		NMAccessPoint* _tmp20_;
		NM80211ApSecurityFlags _tmp21_;
		GtkImage* _tmp28_;
		gboolean _tmp29_;
		GtkImage* _tmp30_;
		GtkImage* _tmp31_;
		gboolean _tmp32_;
		gboolean _tmp33_;
		GtkImage* _tmp34_;
		GtkSpinner* _tmp35_;
		_tmp9_ = self->priv->img_strength;
		_tmp10_ = network_wifi_menu_item_get_strength (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = network_wifi_menu_item_strength_to_string (self, _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strconcat ("network-wireless-signal-", _tmp13_, NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strconcat (_tmp15_, "-symbolic", NULL);
		_tmp17_ = _tmp16_;
		g_object_set (_tmp9_, "icon-name", _tmp17_, NULL);
		_g_free0 (_tmp17_);
		_g_free0 (_tmp15_);
		_g_free0 (_tmp13_);
		_tmp18_ = self->priv->img_strength;
		gtk_widget_show_all ((GtkWidget*) _tmp18_);
		_tmp19_ = network_wifi_menu_item_get_ap (self);
		_tmp20_ = _tmp19_;
		flags = nm_access_point_get_wpa_flags (_tmp20_);
		self->is_secured = FALSE;
		_tmp21_ = flags;
		if ((_tmp21_ & NM_802_11_AP_SEC_GROUP_WEP40) == NM_802_11_AP_SEC_GROUP_WEP40) {
			self->is_secured = TRUE;
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses 40/64-bit WEP encryption"));
		} else {
			NM80211ApSecurityFlags _tmp22_;
			_tmp22_ = flags;
			if ((_tmp22_ & NM_802_11_AP_SEC_GROUP_WEP104) == NM_802_11_AP_SEC_GROUP_WEP104) {
				self->is_secured = TRUE;
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses 104/128-bit WEP encryption"));
			} else {
				NM80211ApSecurityFlags _tmp23_;
				_tmp23_ = flags;
				if ((_tmp23_ & NM_802_11_AP_SEC_KEY_MGMT_PSK) == NM_802_11_AP_SEC_KEY_MGMT_PSK) {
					self->is_secured = TRUE;
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses WPA encryption"));
				} else {
					gboolean _tmp24_ = FALSE;
					NM80211ApSecurityFlags _tmp25_;
					_tmp25_ = flags;
					if (_tmp25_ != NM_802_11_AP_SEC_NONE) {
						_tmp24_ = TRUE;
					} else {
						NMAccessPoint* _tmp26_;
						NMAccessPoint* _tmp27_;
						_tmp26_ = network_wifi_menu_item_get_ap (self);
						_tmp27_ = _tmp26_;
						_tmp24_ = nm_access_point_get_rsn_flags (_tmp27_) != NM_802_11_AP_SEC_NONE;
					}
					if (_tmp24_) {
						self->is_secured = TRUE;
						gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses encryption"));
					} else {
						gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network is unsecured"));
					}
				}
			}
		}
		_tmp28_ = self->priv->lock_img;
		_tmp29_ = self->is_secured;
		gtk_widget_set_visible ((GtkWidget*) _tmp28_, !_tmp29_);
		_tmp30_ = self->priv->lock_img;
		_tmp31_ = self->priv->lock_img;
		_tmp32_ = gtk_widget_get_visible ((GtkWidget*) _tmp31_);
		_tmp33_ = _tmp32_;
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp30_, !_tmp33_);
		_tmp34_ = self->priv->error_img;
		network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp34_);
		_tmp35_ = self->priv->spinner;
		network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp35_);
	}
	_tmp36_ = self->priv->_state;
	switch (_tmp36_) {
		case NETWORK_STATE_FAILED_WIFI:
		{
			GtkImage* _tmp37_;
			_tmp37_ = self->priv->error_img;
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp37_);
			break;
		}
		case NETWORK_STATE_CONNECTING_WIFI:
		{
			GtkSpinner* _tmp38_;
			GtkRadioButton* _tmp39_;
			gboolean _tmp40_;
			gboolean _tmp41_;
			_tmp38_ = self->priv->spinner;
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp38_);
			_tmp39_ = self->priv->radio_button;
			_tmp40_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp39_);
			_tmp41_ = _tmp40_;
			if (!_tmp41_) {
				g_critical ("WifiMenuItem.vala:158: An access point is being connected but not acti" \
"ve.");
			}
			break;
		}
		default:
		break;
	}
}


void
network_wifi_menu_item_hide_icons (NetworkWifiMenuItem* self)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	g_return_if_fail (self != NULL);
	self->priv->show_icons = FALSE;
	_tmp0_ = self->priv->error_img;
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp0_);
	_tmp1_ = self->priv->lock_img;
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->img_strength;
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp2_);
}


static void
network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	gtk_widget_set_visible (w, TRUE);
	_tmp0_ = gtk_widget_get_visible (w);
	_tmp1_ = _tmp0_;
	gtk_widget_set_no_show_all (w, !_tmp1_);
}


static void
network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	gtk_widget_set_visible (w, FALSE);
	_tmp0_ = gtk_widget_get_visible (w);
	_tmp1_ = _tmp0_;
	gtk_widget_set_no_show_all (w, !_tmp1_);
}


void
network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self,
                               NMAccessPoint* ap)
{
	GeeLinkedList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ap != NULL);
	_tmp0_ = self->priv->_ap;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, ap);
	network_wifi_menu_item_update_tmp_ap (self);
	network_wifi_menu_item_update (self);
}


static gchar*
network_wifi_menu_item_strength_to_string (NetworkWifiMenuItem* self,
                                           guint8 strength)
{
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (((gint) strength) < 30) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("weak");
		result = _tmp0_;
		return result;
	} else {
		if (((gint) strength) < 55) {
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("ok");
			result = _tmp1_;
			return result;
		} else {
			if (((gint) strength) < 80) {
				gchar* _tmp2_;
				_tmp2_ = g_strdup ("good");
				result = _tmp2_;
				return result;
			} else {
				gchar* _tmp3_;
				_tmp3_ = g_strdup ("excellent");
				result = _tmp3_;
				return result;
			}
		}
	}
}


gboolean
network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self,
                                  NMAccessPoint* ap)
{
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ap != NULL, FALSE);
	_tmp0_ = self->priv->_ap;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, ap);
	network_wifi_menu_item_update_tmp_ap (self);
	_tmp1_ = self->priv->_ap;
	_tmp2_ = gee_collection_get_is_empty ((GeeCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	result = !_tmp3_;
	return result;
}


GBytes*
network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self)
{
	GBytes* result;
	NMAccessPoint* _tmp0_;
	GBytes* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tmp_ap;
	_tmp1_ = nm_access_point_get_ssid (_tmp0_);
	result = _tmp1_;
	return result;
}


NetworkState
network_wifi_menu_item_get_state (NetworkWifiMenuItem* self)
{
	NetworkState result;
	NetworkState _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}


void
network_wifi_menu_item_set_state (NetworkWifiMenuItem* self,
                                  NetworkState value)
{
	g_return_if_fail (self != NULL);
	if (network_wifi_menu_item_get_state (self) != value) {
		self->priv->_state = value;
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY]);
	}
}


gboolean
network_wifi_menu_item_get_active (NetworkWifiMenuItem* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_active;
	result = _tmp0_;
	return result;
}


void
network_wifi_menu_item_set_active (NetworkWifiMenuItem* self,
                                   gboolean value)
{
	g_return_if_fail (self != NULL);
	if (network_wifi_menu_item_get_active (self) != value) {
		self->priv->_active = value;
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY]);
	}
}


guint8
network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self)
{
	guint8 result;
	guint8 strength = 0U;
	guint8 _tmp13_;
	g_return_val_if_fail (self != NULL, 0U);
	strength = (guint8) 0;
	{
		GeeLinkedList* _ap_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _ap_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _ap_index = 0;
		_tmp0_ = self->priv->_ap;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_ap_list = _tmp1_;
		_tmp2_ = _ap_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_ap_size = _tmp4_;
		_ap_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			NMAccessPoint* ap = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			guint8 _tmp11_;
			NMAccessPoint* _tmp12_;
			_tmp5_ = _ap_index;
			_ap_index = _tmp5_ + 1;
			_tmp6_ = _ap_index;
			_tmp7_ = _ap_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _ap_list;
			_tmp9_ = _ap_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			ap = (NMAccessPoint*) _tmp10_;
			_tmp11_ = strength;
			_tmp12_ = ap;
			strength = MAX (_tmp11_, nm_access_point_get_strength (_tmp12_));
			_g_object_unref0 (ap);
		}
		_g_object_unref0 (_ap_list);
	}
	_tmp13_ = strength;
	result = _tmp13_;
	return result;
}


NMAccessPoint*
network_wifi_menu_item_get_ap (NetworkWifiMenuItem* self)
{
	NMAccessPoint* result;
	NMAccessPoint* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tmp_ap;
	result = _tmp0_;
	return result;
}


static void
network_wifi_menu_item_class_init (NetworkWifiMenuItemClass * klass)
{
	network_wifi_menu_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NetworkWifiMenuItemPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_menu_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_menu_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = network_wifi_menu_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY] = g_param_spec_boxed ("ssid", "ssid", "ssid", G_TYPE_BYTES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY] = g_param_spec_uchar ("strength", "strength", "strength", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_AP_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_AP_PROPERTY] = g_param_spec_object ("ap", "ap", "ap", nm_access_point_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL] = g_signal_new ("user-action", NETWORK_TYPE_WIFI_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
network_wifi_menu_item_instance_init (NetworkWifiMenuItem * self)
{
	self->priv = NETWORK_WIFI_MENU_ITEM_GET_PRIVATE (self);
	self->priv->_state = NETWORK_STATE_DISCONNECTED;
	self->priv->show_icons = TRUE;
}


static void
network_wifi_menu_item_finalize (GObject * obj)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	_g_object_unref0 (self->priv->_ap);
	_g_object_unref0 (self->priv->_tmp_ap);
	_g_object_unref0 (self->priv->radio_button);
	_g_object_unref0 (self->priv->img_strength);
	_g_object_unref0 (self->priv->lock_img);
	_g_object_unref0 (self->priv->error_img);
	_g_object_unref0 (self->priv->spinner);
	G_OBJECT_CLASS (network_wifi_menu_item_parent_class)->finalize (obj);
}


GType
network_wifi_menu_item_get_type (void)
{
	static volatile gsize network_wifi_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&network_wifi_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiMenuItem), 0, (GInstanceInitFunc) network_wifi_menu_item_instance_init, NULL };
		GType network_wifi_menu_item_type_id;
		network_wifi_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkWifiMenuItem", &g_define_type_info, 0);
		g_once_init_leave (&network_wifi_menu_item_type_id__volatile, network_wifi_menu_item_type_id);
	}
	return network_wifi_menu_item_type_id__volatile;
}


static void
_vala_network_wifi_menu_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	switch (property_id) {
		case NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY:
		g_value_set_boxed (value, network_wifi_menu_item_get_ssid (self));
		break;
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
		g_value_set_enum (value, network_wifi_menu_item_get_state (self));
		break;
		case NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY:
		g_value_set_boolean (value, network_wifi_menu_item_get_active (self));
		break;
		case NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY:
		g_value_set_uchar (value, network_wifi_menu_item_get_strength (self));
		break;
		case NETWORK_WIFI_MENU_ITEM_AP_PROPERTY:
		g_value_set_object (value, network_wifi_menu_item_get_ap (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_network_wifi_menu_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
	switch (property_id) {
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
		network_wifi_menu_item_set_state (self, g_value_get_enum (value));
		break;
		case NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY:
		network_wifi_menu_item_set_active (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



